package com.huimv.guowei.admin.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.druid.util.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.guowei.admin.common.utils.Result;
import com.huimv.guowei.admin.common.utils.ResultCode;
import com.huimv.guowei.admin.entity.EnvWarningThreshold;
import com.huimv.guowei.admin.service.IEnvWarningInfoService;
import com.huimv.guowei.admin.service.IEnvWarningThresholdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-06-01
 */
@RestController
@RequestMapping("/env-warning-threshold")
public class EnvWarningThresholdController {
    @Autowired
    private IEnvWarningThresholdService envWarningThresholdService;

    @PostMapping("/saveThreshold")
    public Result saveThreshold(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        String maxTem = paramsMap.get("maxTem");
        String minTem = paramsMap.get("minTem");
        String maxHum = paramsMap.get("maxHum");
        String minHum = paramsMap.get("minHum");
        maxTem = nullParameter(maxTem);
        minTem = nullParameter(minTem);
        maxHum = nullParameter(maxHum);
        minHum = nullParameter(minHum);

        EnvWarningThreshold envWarningThreshold = new EnvWarningThreshold();
        envWarningThreshold.setFarmId(Integer.parseInt(farmId));
        envWarningThreshold.setMaxHum(maxHum);
        envWarningThreshold.setMinHum(minHum);
        envWarningThreshold.setMaxTem(maxTem);
        envWarningThreshold.setMinTem(minTem);
        envWarningThresholdService.saveOrUpdate(envWarningThreshold,new UpdateWrapper<EnvWarningThreshold>().eq("farm_id",farmId));
        return Result.SUCCESS();
    }
    @PostMapping("/getThreshold")
    public Result getThreshold(@RequestBody Map<String ,String> paramsMap){
        String farmId = paramsMap.get("farmId");
        EnvWarningThreshold envWarningThreshold = envWarningThresholdService.getOne(new QueryWrapper<EnvWarningThreshold>().eq("farm_id", farmId));
        if (ObjectUtil.isEmpty(envWarningThreshold)) {
            envWarningThreshold.setMaxTem("0");
            envWarningThreshold.setMinTem("0");
            envWarningThreshold.setMaxHum("0");
            envWarningThreshold.setMinHum("0");
        }
        return new Result(ResultCode.SUCCESS,envWarningThreshold);
    }
    public String nullParameter(String param){
        if (StringUtils.isEmpty(param)){
            param = "0";
        }
        return param;
    }

}
